/**************************************************************************
      Author:   Jean-Marie T'Jaeckx, ON7EN
        Date:   4 Aug 2019
    Hardware:   Arduino NANO, BME280 module , 0.96" I2C IIC Serial 128X64 lcd
    Software:   Arduino IDE 1.8.9;
       Legal:   Copyright (c) 2019  Jean-Marie T'Jaeckx
                everybody may use this software for non commercial use only
                do me a favor , send me a picture from your project  on7en@skynet.be

  Description:   reads temperature and pressure
  how to use ?
  after power up  temperature and pressure+PRESET  is displayed every 5 seconds.you can change this in line 107 and 120
  why an PRESET ?
  pressure changes with your altitude
  to correct :find your altitude in feet and divide this with 27.3. add this to the PRESET (is kept in memory so you need to do this only once)
  power up while pressing button A1 resets the PRESET
  power up while pressing both buttons will show you a counter. when you see your calculate value depress the buttons


 *************************************************************************/

#include <EEPROM.h>
#include <Arduino.h>
#include <U8g2lib.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>

#include <Wire.h>
#define SEALEVELPRESSURE_HPA (1013.25)

Adafruit_BMP280 bmp; // I2C


//U8G2_SH1106_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);
//U8G2_SSD1306_128X64_NONAME_1_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);
//U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);

U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);
int extra = 15;
int offset = 14;
int teller = 0;
int druk=1;
const int debounceDelay = 50; // milliseconds to wait until stable
boolean menu = false; // true when in menu mode

void setup(void) {
  u8g2.begin();
  bmp.begin(0x76);
  // bme.begin();
  u8g2.firstPage();
  do {
    // u8g2.setFont(u8g2_font_ncenB12_tn );
    //u8g2.setCursor(0, 0);
    // u8g2.print("Power Meter");
    u8g2.setFont(u8g2_font_ncenB10_tr); // choose a suitable font
    //EEPROM.get(0, teller);


    u8g2.setCursor(20, 50);
    // u8g2.print("offset= +");u8g2.print(teller);

    u8g2.drawStr(10, 15, "  BAROMETER");  // write something to the internal memory

    u8g2.setFont(u8g2_font_fub14_tr);

    u8g2.setCursor(20, 30);
  //  u8g2.print("  F8GPP");
    u8g2.setCursor(10, 45);
    u8g2.setFont(u8g2_font_ncenB10_tr);
    u8g2.print("offset = "); teller = u8g2.print(EEPROM.read(0)); u8g2.print(teller,0); u8g2.print( " hPa");
u8g2.setCursor(10, 60);
u8g2.setFont(u8g2_font_ncenB08_tr);
u8g2.print("   soft by ON7EN");
    delay(5000);

  } while ( u8g2.nextPage() );
  delay(3000);                // Wait 3 seconds
  bmp.setSampling(Adafruit_BMP280::MODE_NORMAL,     /* Operating Mode. */
                  Adafruit_BMP280::SAMPLING_X2,     /* Temp. oversampling */
                  Adafruit_BMP280::SAMPLING_X16,    /* Pressure oversampling */
                  Adafruit_BMP280::FILTER_X16,      /* Filtering. */
                  Adafruit_BMP280::STANDBY_MS_500); /* Standby time. */
  pinMode(A0, INPUT);
  pinMode(A1, INPUT);
  digitalWrite(A0 , HIGH);
  digitalWrite(A1 , HIGH);

}
//REV = analogRead(A9);
void loop() {
  // u8g2.begin();
  if (digitalRead(A0) == HIGH and digitalRead(A1) == LOW) {
    EEPROM.write(0, 0);
    u8g2.clearBuffer();          // clear the internal memory
  u8g2.setFont(u8g2_font_ncenB10_tr); // choose a suitable font
  u8g2.drawStr(0, 35, "RESET offset");
    u8g2.sendBuffer();
    delay(2000);
  };
  if (digitalRead(A0) == LOW and digitalRead(A1) == LOW) {
    teller=teller+1;
    EEPROM.write(0, teller);
     u8g2.clearBuffer();
    u8g2.setFont(u8g2_font_fub20_tr);
    u8g2.setCursor(0, 45);

    u8g2.print( " +"); u8g2.print(teller); u8g2.print("  hPa");
   
    u8g2.sendBuffer();
     delay(1500);
   // return;
  };
  if (digitalRead(A0) == HIGH and digitalRead(A1) == HIGH) {
  u8g2.clearBuffer();					// clear the internal memory
  u8g2.setFont(u8g2_font_ncenB10_tr); // choose a suitable font
  u8g2.drawStr(0, 15, "TEMPERATUUR");	// write something to the internal memory
  u8g2.setFont(u8g2_font_fub25_tr);
  u8g2.setCursor(20, 55);
  u8g2.print( bmp.readTemperature()-1, 1); // write something to the internal memory
  u8g2.print( " C");
  u8g2.sendBuffer();					// transfer internal memory to the display
  delay(5000);
  u8g2.clearBuffer();          // clear the internal memory
  u8g2.setFont(u8g2_font_ncenB10_tr); // choose a suitable font
  u8g2.drawStr(0, 15, "      DRUK");
  
   u8g2.setFont(u8g2_font_fub20_tr);
  teller = EEPROM.read(0);
  u8g2.setCursor(5, 55);
  druk = int(bmp.readPressure()/ 100.0F);//int(teller);
  u8g2.print(druk+teller);//u8g2.print("  ");
  u8g2.print(" hPa");

  u8g2.sendBuffer();          // transfer internal memory to the display
  delay(5000);
  }
}
